/**
 * Ce programme sert  montrer l'utilisation
 * des listes et quelques algorithmes de la
 * classe Collections.

 * @author Livre Sun "Tutorial de Java" (p 43)
 * @author Guy Lapalme (version fr)
 * @author Mohamed Lokbani (qcqs commentaires en plus)

 * @version 1.3
 */




import java.util.*;

class Deal {

    // nom de procdure suivante trs appropri !!!
    public static void main(String args[]) {  
        
	// nombre de mains
        int nbMains = Integer.parseInt(args[0]);

	// nombre de cartes par main
        int cartesParMain = Integer.parseInt(args[1]);

        // crer un paquet normal de cartes
        String[] couleur = new String[]
            {"pique", "coeur", "carreau", "trfle"};
        String[] valeur = new String[]
            {"as","2","3","4","5","6","7","8","9","10","valet","reine","roi"};
	
	// on insre ce paquet dans une List
        List paquet = new ArrayList();
        for (int i=0; i<couleur.length; i++)
            for (int j=0; j<valeur.length; j++)
                paquet.add(valeur[j] + " de " + couleur[i]);

        // brasser le paquet de manire alatoire
        Collections.shuffle(paquet);
        
        // distribuer les mains
        for (int i=0; i<nbMains; i++)
            System.out.println(uneMain(paquet, cartesParMain));
    }

    /**
       donner n cartes du paquet en les enlevant de la fin

       @param paquet Une liste contenant les cartes
       @param n nombre de cartes par main
    */

    public static List uneMain(List paquet, int n) {
        int grandeurPaquet = paquet.size();
        List vueMain = paquet.subList(grandeurPaquet-n, grandeurPaquet);
        List laMain = new ArrayList(vueMain);
        vueMain.clear();
        return laMain;
    }
}

/* exemple de rsultat: attention vous pouvez obtenir un
rsultat diffrent que celui-ci  cause de la mthode
shuffle (tirage suit une loi probabiliste).

=> java Deal 5 4
[8 de coeur, 8 de pique, roi de coeur, 9 de trfle]
[6 de coeur, 4 de coeur, roi de trfle, 6 de carreau]
[8 de trfle, reine de trfle, valet de carreau, 10 de coeur]
[6 de trfle, 5 de trfle, valet de pique, 2 de trfle]
[6 de pique, as de pique, as de trfle, reine de carreau]

*/
